using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using CE3IO;
namespace mbe
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
#if MONO
			this.MenuFilePageSetup.Enabled = false;
			this.MenuFilePrint.Enabled = false;
			this.MenuFilePrintPreview.Enabled = false;
#endif


            mbeView.PrintLeftMargin = Properties.Settings.Default.PrintLeftMargin;
            mbeView.PrintBottomMargin = Properties.Settings.Default.PrintBottomMargin;

            mbeView.Print2xMode = Properties.Settings.Default.Print2xMode;
            mbeView.CenterPunchMode = Properties.Settings.Default.CenterPunchMode;
            mbeView.PrintToolMarkMode = Properties.Settings.Default.ToolMarkPrint;
            mbeView.PrintColorMode = (MbeView.PrintColorModeValue)Properties.Settings.Default.PrintColorMode;
            mbeView.ExportImageColorMode = Properties.Settings.Default.ImageColorMode;


			if (Properties.Settings.Default.MainWindowState == 1) {
				WindowState = FormWindowState.Maximized;
			} else {
				int cx = Properties.Settings.Default.MainWindowWidth;
				int cy = Properties.Settings.Default.MainWindowHeight;
				Size = new Size(cx, cy);
			}

            componentLibrary = new MbeLibs();

			lastCanBulkPropResult = new CanBulkPropResult();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			MbeColors.InitColor();
			MbeColors.LoadSettings();
			mbeView.SetWorkAreaSize(MbeView.WORK_AREA_DEFAULT_WIDTH, MbeView.WORK_AREA_DEFAULT_HEIGHT);
			mbeView.EnablePaint = true;
			setLayerWindow.EnablePaint = true;
			mbeView.SetMode(MbeView.ModeMajor.SelectorMode);

            LoadLibraries();

            LoadToolMark();
            
			//tBarMajor̓c[o[\Ă郂[h
			//tBarMajorƎۂɃ[hقȂƂɃc[o[XVB
			//lSelectorModeȊÔǂꂩƂB
			tBarMajor = MbeView.ModeMajor.SetGridOriginMode;


			string[] cmdlineParam;
			cmdlineParam = System.Environment.GetCommandLineArgs();
            if (cmdlineParam.Length > 1) {
                string path = cmdlineParam[1];
                if (!DoFileOpen(path)) {
                    SetTitle();
                }
            } else {
                SetTitle();
            }

            DisplayGridValue();
			//SetToolBarButton();
        }

        private void FileExit_ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //System.Windows.Forms.Application.Exit();
            Close();
        }

        private void Form1_Closing(object sender, FormClosingEventArgs e)
        {
			if (QueryCloseCurrentWork("MBE")) {
				SaveWindowState();
				Properties.Settings.Default.Save();
				return;
			} else {
				e.Cancel = true; //trueݒ肷ƃN[YLZłB
			}
        }

		private void PanelClientSizeChanged(object sender, EventArgs e)
		{
			Size clientSize = mbeView.ClientSize;
		}

		protected override void OnShown(EventArgs e)
		{
			base.OnShown(e);
			if (!mbeView.BoardFontReady) {
				MessageBox.Show("Initialization of font data isn't complete.", "MBE");
			}
		}

		private void OnMouseMoveView(object sender, MouseEventArgs e)
		{
			Point point = mbeView.CursorPos;
			double x = (double)point.X / 10000;
			double y = (double)point.Y / 10000;

			toolStripDimText.Text = String.Format("Abs({0,8:F3}mm,{1,8:F3}mm)", x, y);

			if (!mbeView.CursorGridCoodPos.Equals(point)) {
				point = mbeView.CursorGridCoodPos;
				x = (double)point.X / 10000;
				y = (double)point.Y / 10000;
				this.toolStripDimGridOriginText.Text = String.Format("Rel({0,8:F3}mm,{1,8:F3}mm)", x, y);
			} else {
				this.toolStripDimGridOriginText.Text = "";
			}

            this.toolStripSnapPointProperty.Text = mbeView.ComponentPinProperty;

			statusStrip1.Refresh();//ȂƂɍXVȂ

		}

		//Setj[
		//private void OnMenuSetGrid(object sender, EventArgs e)
		//{
		//    System.Diagnostics.Debug.WriteLine("OnMenuSetGrid");
		//}

		//protected const double ZOOM_STEP = 1.5F; 

		private void OnMenuViewZoomIn(object sender, EventArgs e)
		{
			mbeView.ZoomInOut(true);
		}

		private void OnMenuViewZoomOut(object sender, EventArgs e)
		{
			mbeView.ZoomInOut(false);
		}

		///// <summary>
		///// Viewj[JꂽƂ̏
		///// </summary>
		///// <param name="sender"></param>
		///// <param name="e"></param>
		///// <remarks>
		///// zoomڂ̗Lݒ
		///// </remarks>
		//private void OnOpeningMenuView(object sender, EventArgs e)
		//{
		//    double scale = mbeView.DisplayScale;
		//    //System.Diagnostics.Debug.WriteLine("OnOpeningMenuView() "+ scale);
		//    this.MenuViewZoomOut.Enabled = (scale * 1.5F <= MbeView.MAX_DISPLAY_SCALE);
		//    this.MenuViewZoomIn.Enabled = (scale / 1.5F >= MbeView.MIN_DISPLAY_SCALE);
		//}

		/// <summary>
		/// Viewj[̃ACẽCl[u̐ݒ
		/// </summary>
		/// <remarks>^C}[CxgŌĂ΂</remarks>
		private void SetMenuViewItemEnable()
		{
			double scale = mbeView.DisplayScale;
			//System.Diagnostics.Debug.WriteLine("OnOpeningMenuView() "+ scale);
			this.MenuViewZoomOut.Enabled = (scale * 1.5F <= MbeView.MAX_DISPLAY_SCALE);
			this.MenuViewZoomIn.Enabled = (scale / 1.5F >= MbeView.MIN_DISPLAY_SCALE);
		}

		/// <summary>
		/// SetGridj[JꂽƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// [hɑΉ`FbN
		/// </remarks>
		private void OnOpeningMenuSetGrid(object sender, EventArgs e)
		{
			MbeView.ModeMajor major;
			int minor;//dummy
			mbeView.GetMode(out major, out minor);
			this.MenuSetGridOrigin.Checked = (major == MbeView.ModeMajor.SetGridOriginMode); 
		}

		private void OnMenuSetGridOrigin(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.SetGridOriginMode);
			//SetToolBarButton();
		}

		private void OnMenuSetResetGridOrigin(object sender, EventArgs e)
		{
			Point pt = new Point(0, 0);
			mbeView.SetMode(MbeView.ModeMajor.SelectorMode);
			mbeView.SetGridOrigin(pt);

		}

		private void OnMenuHelpAbout(object sender, EventArgs e)
		{
			//MessageBox.Show("MBE","About");
			AboutBoxForm dlg = new AboutBoxForm();
			dlg.ShowDialog();
		}

		private void OnMenuSetGridValue(object sender, EventArgs e)
		{
			SetGridForm dlg = new SetGridForm();

            dlg.CurrentGridInfo = mbeView.CurrentGridInfo;
            //dlg.MyStandardGrid = mbeView.MyStandardGrid;
            DialogResult retv = dlg.ShowDialog();
			if (retv == DialogResult.OK) {
                mbeView.SetCurrentGridInfo(dlg.CurrentGridInfo);

                DisplayGridValue();
			}

           
            //System.Diagnostics.Debug.WriteLine("OnMenuSetGridValue "+retv);
		}

        private void DisplayGridValue()
        {
            double x = (double)(mbeView.CurrentGridInfo.Horizontal) / 10000;
            double y = (double)(mbeView.CurrentGridInfo.Vertical) / 10000;
            toolStripGridVal.Text = String.Format("Grid[{0:#0.0###}mm,{1:#0.0###}mm]", x, y);

            statusStrip1.Refresh();//ȂƂɍXVȂ
        }


		/// <summary>
		/// mbeViewIC[ύXƂsetLayerWindowɃZbg
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// MainFormAMbeViewg[hύXƁAIC[
		/// \C[ςBC[ݒEBhEɒʒmB
		/// </remarks>
		private void OnLayerSelectChange(object sender, LayerInfoEventArgs e)
		{
			setLayerWindow.OnLayerSelectInfoChange(sender, e);
		}

		/// <summary>
		/// mbeViewg[hύXƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		//private void OnViewChangeMode(object sender, EventArgs e)
		//{
		//    SetToolBarButton();
		//}

		private MbeView.ModeMajor tBarMajor;

        private MbeLibs componentLibrary;

        //public static MbeLib toolMarkLib;


		/// <summary>
		/// mbeView烂[h𓾂āAc[o[̃{^̏Ԃݒ肷B
		/// </summary>
		private void SetModeInfo()
		{
			MbeView.ModeMajor major;
			int minor;
			mbeView.GetMode(out major, out minor);
			//if (major == MbeView.ModeMajor.SelectorMode) {
			//    this.ContextMenuStrip = this.contextMenu;
			//} else {
			//    this.ContextMenuStrip = null;
			//}

			if (tBarMajor != major) {
				TBarSelector.Checked = (major == MbeView.ModeMajor.SelectorMode);
				TBarConChk.Checked = (major == MbeView.ModeMajor.ConChkMode);
				TBarHole.Checked = (major == MbeView.ModeMajor.PlaceHole);
				TBarPTH.Checked = (major == MbeView.ModeMajor.PlacePTH);
				TBarSMD.Checked = (major == MbeView.ModeMajor.PlacePad);
				TBarLine.Checked = (major == MbeView.ModeMajor.PlaceLine);
				TBarARC.Checked = (major == MbeView.ModeMajor.PlaceArc);
				TBarText.Checked = (major == MbeView.ModeMajor.PlaceText);
				TBarPolygon.Checked = (major == MbeView.ModeMajor.PlacePolygon);
                TBarComponent.Checked = (major == MbeView.ModeMajor.PlaceComponent);
				tBarMajor = major;
			}
		}


		private void OnOpenMenuTool(object sender, EventArgs e)
		{
			MbeView.ModeMajor major;
			int minor;
			mbeView.GetMode(out major, out minor);
			this.MenuToolSelector.Checked = (major == MbeView.ModeMajor.SelectorMode);
			this.MenuToolConnectionCheck.Checked = (major == MbeView.ModeMajor.ConChkMode);
			this.MenuToolHole.Checked = (major == MbeView.ModeMajor.PlaceHole);
			this.MenuToolPTH.Checked = (major == MbeView.ModeMajor.PlacePTH);
			this.MenuToolPad.Checked = (major == MbeView.ModeMajor.PlacePad);
			this.MenuToolLine.Checked = (major == MbeView.ModeMajor.PlaceLine);
			this.MenuToolPolygon.Checked = (major == MbeView.ModeMajor.PlacePolygon);
			this.MenuToolArc.Checked = (major == MbeView.ModeMajor.PlaceArc);
			this.MenuToolText.Checked = (major == MbeView.ModeMajor.PlaceText);
            this.MenuToolComponent.Checked = (major == MbeView.ModeMajor.PlaceComponent);
		}

		/// <summary>
		/// Toolj[̃ZN^IƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuToolSelector(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.SelectorMode);
			//SetToolBarButton();
		}

		/// <summary>
		/// c[o[̃ZN^NbNƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnTBarSelector(object sender, EventArgs e)
		{
			OnMenuToolSelector(sender, e);
		}

		/// <summary>
		/// Toolj[ConChkIƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuToolConChk(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.ConChkMode);
		}

		/// <summary>
		/// c[o[ConChkNbNƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnTBarConChk(object sender, EventArgs e)
		{
			OnMenuToolConChk(sender, e);
		}


		/// <summary>
		/// Toolj[HoleIƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuToolHole(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.PlaceHole);
		}

		/// <summary>
		/// c[o[HoleNbNƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnTBarHole(object sender, EventArgs e)
		{
			OnMenuToolHole(sender, e);
		}


		/// <summary>
		/// Toolj[PadTHIƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuToolPTH(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.PlacePTH);
		}

		/// <summary>
		/// c[o[PinTHNbNƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnTBarPTH(object sender, EventArgs e)
		{
			OnMenuToolPTH(sender, e);
		}

		/// <summary>
		/// Toolj[PADIƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuToolPad(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.PlacePad);
		}

		/// <summary>
		/// c[o[PADNbNƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnTBarSMD(object sender, EventArgs e)
		{
			OnMenuToolPad(sender, e);
		}

		/// <summary>
		/// Toolj[LineIƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuToolLine(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.PlaceLine);
		}

		/// <summary>
		/// c[o[LineNbNƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnTBarLine(object sender, EventArgs e)
		{
			OnMenuToolLine(sender, e);
		}

		private void OnMenuToolArc(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.PlaceArc);
		}

		private void OnTBarArc(object sender, EventArgs e)
		{
			OnMenuToolArc(sender, e);
		}



		private void OnMenuToolText(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.PlaceText);
		}

		private void OnTBarText(object sender, EventArgs e)
		{
			OnMenuToolText(sender, e);
		}

		private void OnMenuSetColor(object sender, EventArgs e)
		{
			SetColorForm dlg = new SetColorForm();
			dlg.ColorChange += new SetColorForm.ColorChangeHandler(this.OnColorChange);
			dlg.ShowDialog();
		}

		private void OnMenuToolPolygon(object sender, EventArgs e)
		{
			mbeView.SetMode(MbeView.ModeMajor.PlacePolygon);
		}

		private void OnTBarPolygon(object sender, EventArgs e)
		{
			OnMenuToolPolygon(sender, e);
		}

        private void OnMenuToolComponent(object sender, EventArgs e)
        {
            mbeView.mbeLibs = componentLibrary;
            mbeView.SetMode(MbeView.ModeMajor.PlaceComponent);
        }

        private void OnTBarComponent(object sender, EventArgs e)
        {
            OnMenuToolComponent(sender, e);
        }

		/// <summary>
		/// SetLayerWindowőIC[ύXƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnSelectLayerChange(object sender, LayerInfoEventArgs e)
		{
			mbeView.SelectLayer = e.selectLayer;
			mbeView.SetVisibleLayer(e.visibleLayer);
		}

		/// <summary>
		/// SetLayerWindowŉC[ύXƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnVisibleLayerChange(object sender, LayerInfoEventArgs e)
		{
			mbeView.SetVisibleLayer(e.visibleLayer);
		}

		/// <summary>
		/// SetLayerWindowŃC[\FύXƂ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnLayerColorChange(object sender, EventArgs e)
		{
			mbeView.RedrawAll();
		}


		private void OnColorChange(object sender, EventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("OnColorChange");
			mbeView.RedrawAll();
			setLayerWindow.Invalidate();
		}



		/// <summary>
		/// ^Cgo[̐ݒ
		/// </summary>
		protected void SetTitle()
		{
            string TitleText = Properties.Settings.Default.MainTitleText;
            if (TitleText.Length == 0) {
                TitleText = "mbe";
                Properties.Settings.Default.MainTitleText = TitleText;
            }

			if (mbeView.Document.DocumentName != null && mbeView.Document.DocumentName.Length > 0) {
                this.Text = mbeView.Document.DocumentName + " - " + TitleText;  // "mbe";
			} else {
                this.Text = TitleText;  // "mbe";
			}
		}



        private bool DocumentIsVoid()
        {
            mbeView.Document.ReleaseTemp();
            mbeView.RedrawAll();
            return (mbeView.Document.MainList.Count == 0);
        }


		/// <summary>
		/// t@CI[vFILE-NEWɂČ݂̃[ÑNA𑱍s邩q˂
		/// </summary>
		/// <returns>݂̃[NNAłƂtrueԂ</returns>
		private bool QueryCloseCurrentWork(string msgTitle)
		{
			mbeView.Document.ReleaseTemp();
			mbeView.RedrawAll();
			if (!mbeView.Document.DocModified){
				return true;	// ModifiedłȂtrueԂ
			} else {
				string fname = mbeView.Document.DocumentName;
				if (fname.Length == 0) fname = "Untitled";
				//uۑ܂?vyes no cancel
				DialogResult dr = MessageBox.Show("Save changes to " + fname + "?", msgTitle ,
					MessageBoxButtons.YesNoCancel,MessageBoxIcon.Question);
				if (dr == DialogResult.Cancel) {
					return false;	//sȂ
				} else if (dr == DialogResult.Yes) {
					bool saveResult;
					if (mbeView.Document.DocumentPath.Length == 0) {
						saveResult = DoFileSaveAs();
					} else {
						saveResult = DoFileSave();
					}
					if (!saveResult) return false;
					else return true;
				} else {
					return true;	//NoIBۑɑs
				}
			}

		}

		private void OnMenuFileNew(object sender, EventArgs e)
		{
            if (!DocumentIsVoid()){
                System.Diagnostics.Process.Start(Application.ExecutablePath);
            }else{
                mbeView.Document.ClearAll();
                SetTitle();
                mbeView.RedrawAll();
            }



            //if(QueryCloseCurrentWork("MBE Clear current document")){
            //    mbeView.Document.ClearAll();
            //    SetTitle();
            //    mbeView.RedrawAll();
            //}
		}

		/// <summary>
		/// t@CI[v̎
		/// </summary>
		private bool DoFileOpen(string path)
		{
            //0.48.04 gqmb3łȂƂ͉ɖ߂
            string ext = Path.GetExtension(path);
            if (string.Compare(ext, ".mb3", true) != 0) return false;

            //0.48.04 ݂̃hLgłȂƂ́AʃEBhEŊJWbNOnMenuFileOpen()ړĂ
            if (!DocumentIsVoid()) {
                string argpath = "\"" + path + "\"";
                System.Diagnostics.Process.Start(Application.ExecutablePath, argpath);
                return true;
            }

			if (mbeView.Document.FileOpen(path) != ReadCE3.RdStatus.NoError) {
				mbeView.Document.ClearAll();
			}
			SetTitle();
			//if (mbeView.Document.MainList.Count > 0) {
			mbeView.SetViewPolygonFrameOnly(true);
				mbeView.RedrawAll();
			//}
                return true;
		}

		/// <summary>
		/// t@CI[v
		/// </summary>
		private void OnMenuFileOpen(object sender, EventArgs e)
		{
			//if (!QueryCloseCurrentWork("MBE Open document")) {
			//    return;
			//}

			OpenFileDialog openFileDialog = new OpenFileDialog();	
			openFileDialog.FileName = "*.mb3";
			openFileDialog.Filter = "MBE file (*.mb3)|*.mb3";
			openFileDialog.DefaultExt = "mb3";
			DialogResult dr= openFileDialog.ShowDialog();
			if (dr == DialogResult.OK) {
                //hLg󂩂ǂ̃`FbŃADoFileOpen()Ɉړ 0.48.04
                //if (!DocumentIsVoid()) {
                //    string path = "\""+openFileDialog.FileName+"\"";
                //    System.Diagnostics.Process.Start(Application.ExecutablePath, path);
                //} else {
                //    string path = openFileDialog.FileName;
                //    DoFileOpen(path);
                //}
                string path = openFileDialog.FileName;
                DoFileOpen(path);



                //if (!QueryCloseCurrentWork("MBE Open document")) {
                //    return;
                //}
                //string path = openFileDialog.FileName;
                //DoFileOpen(path);
			}
		}

		/// <summary>
		/// t@CۑɎsƂ̃bZ[W̕\
		/// </summary>
		/// <param name="fname"></param>
		private void ShowMsgFailToSave(string fname)
		{
			MessageBox.Show("Failed to save " + fname, "MBE",
				MessageBoxButtons.OK, MessageBoxIcon.Stop);
		}

		/// <summary>
		/// ㏑ۑ̎
		/// </summary>
		private bool DoFileSave()
		{
			//string fname = mbeView.Document.DocumentName;
			string path = mbeView.Document.DocumentPath;
			bool result;
			if (path.Length == 0) {
				result =  DoFileSaveAs();
			} else {
				if (!mbeView.Document.FileSave()) {
					string fname = Path.GetFileName(path);
					ShowMsgFailToSave(fname);
					result = false;
				}else{
					result = true;
					mbeView.Document.ClearAll();
					mbeView.Document.FileOpen(path);
					SetTitle();
				}
			}
			mbeView.SetViewPolygonFrameOnly(true);
			mbeView.RedrawAll();
			return result;
		}

		/// <summary>
		/// ㏑ۑ̃nh
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuFileSave(object sender, EventArgs e)
		{
			DoFileSave();
		}

		/// <summary>
		/// Otĕۑ̎
		/// </summary>
		/// <remarks>
		/// t@C̕ۑƂtrueԂ
		/// </remarks>
		private bool DoFileSaveAs()
		{
			SaveFileDialog saveFileDialog = new SaveFileDialog();
			
			saveFileDialog.FileName = "*.mb3";
			saveFileDialog.Filter = "MBE file (*.mb3)|*.mb3";
			saveFileDialog.DefaultExt = "mb3";
			DialogResult dr= saveFileDialog.ShowDialog();
			if (dr == DialogResult.OK) {
				string path = saveFileDialog.FileName;
				if (!mbeView.Document.FileSaveAs(path)) {
					string fname;
					try {
						fname = Path.GetFileName(path);
					}
					catch (Exception) {
						fname = "Untitled";
					}
					ShowMsgFailToSave(fname);
					mbeView.RedrawAll();
					return false;
				}
				mbeView.Document.ClearAll();
				mbeView.Document.FileOpen(path);
				SetTitle();
				mbeView.SetViewPolygonFrameOnly(true);
				mbeView.RedrawAll(); 
				return true;
			}else{
				return false;
			}
		}

		private void OnMenuFileSaveAs(object sender, EventArgs e)
		{
			DoFileSaveAs();
		}


		/// <summary>
		/// Editj[̃ACẽCl[u̐ݒ
		/// </summary>
		/// <remarks>^C}[CxgŌĂ΂</remarks>
		private void SetMenuEditItemEnable()
		{
			bool bCanCopy = mbeView.Document.CanCopy();
			this.MenuEditCopy.Enabled = bCanCopy;
			this.MenuEditCut.Enabled = bCanCopy;
			this.MenuEditDelete.Enabled = bCanCopy;
			this.MenuEditPaste.Enabled = mbeView.Document.CanPaste();
			this.MenuEditUndo.Enabled = mbeView.Document.CanUndo();
			this.MenuEditRedo.Enabled = mbeView.Document.CanRedo();
			this.MenuEditProperty.Enabled = mbeView.Document.CanEditProperty();
			this.MenuEditFlip.Enabled = bCanCopy;
			this.MenuEditRotate.Enabled = bCanCopy;
			this.MenuEditComponenting.Enabled = mbeView.Document.CanComponenting();
			this.MenuEditUncomponenting.Enabled = mbeView.Document.CanUncomponenting();
			this.MenuEditUpdateFillPolygon.Enabled = !MbeView.ViewPolygonFrame;
		}


		//private void OnOpeningMenuEdit(object sender, EventArgs e)
		//{
		//    SetMenuEditItemEnable();
		//    //bool bCanCopy = mbeView.Document.CanCopy();
		//    //this.MenuEditCopy.Enabled = bCanCopy;
		//    //this.MenuEditCut.Enabled = bCanCopy;
		//    //this.MenuEditDelete.Enabled = bCanCopy;
		//    //this.MenuEditPaste.Enabled = mbeView.Document.CanPaste();
		//    //this.MenuEditUndo.Enabled = mbeView.Document.CanUndo();
		//}

		private void OnMenuEditUndo(object sender, EventArgs e)
		{
            mbeView.Undo();
            //mbeView.Document.Undo();
            //mbeView.RedrawAll();
		}

		private void OnMenuEditCut(object sender, EventArgs e)
		{
			//if (mbeView.Document.Copy()) {
			//    mbeView.Document.Delete();
			//    mbeView.RedrawAll();
			//}
			mbeView.Cut();
		}

		private void OnMenuEditCopy(object sender, EventArgs e)
		{
			//System.Diagnostics.Debug.WriteLine("OnMenuEditCopy");
			//mbeView.Document.Copy();
			mbeView.Copy();
		}

		private void OnMenuEditPaste(object sender, EventArgs e)
		{
			mbeView.Paste();
		}

		private void OnMenuEditDelete(object sender, EventArgs e)
		{
			mbeView.Document.Delete();
			mbeView.RedrawAll();
		}

		private void OnMenuEditRotate(object sender, EventArgs e)
		{
			mbeView.Document.Rotate(true);
			mbeView.Invalidate();
		}

		private void OnMenuEditFlip(object sender, EventArgs e)
		{
			mbeView.Flip();
		}

		private void OnMenuEditComponenting(object sender, EventArgs e)
		{
			mbeView.Componenting();
		}

		private void OnMenuEditUncomponenting(object sender, EventArgs e)
		{
			mbeView.UnComponenting();
		}

		private void timer1_Tick(object sender, EventArgs e)
		{
			//System.Diagnostics.Debug.WriteLine("timer1_Tick");
			SetMenuEditItemEnable();
			SetModeInfo();
		}

		private void OnMenuEditProperty(object sender, EventArgs e)
		{
			mbeView.EditProperty();	
		}

		//private void OnOpeningContextMenu(object sender, CancelEventArgs e)
		//{
		//    System.Diagnostics.Debug.WriteLine("OnOpeningContextMenu");
		//    propertyToolStripMenuItem.Enabled = mbeView.Document.CanEditProperty();
		//    addNodeToolStripMenuItem.Enabled = mbeView.CanDivideLine();
		//}

		//private void OnContextMenuProperty(object sender, EventArgs e)
		//{
		//    mbeView.EditProperty();	
		//}

		//private void OnContextMenuAddNode(object sender, EventArgs e)
		//{
		//    //System.Diagnostics.Debug.WriteLine("OnContextMenuAddNode");
		//    mbeView.AddNode();
		//}

		private void OnMenuSetBoardFont(object sender, EventArgs e)
		{
			SetBoardFontForm dlg = new SetBoardFontForm();
			dlg.useEmbeddedFont = Properties.Settings.Default.UseEmbeddedFont;
			dlg.fontPath = Properties.Settings.Default.PathBoardFont;
			DialogResult dr = dlg.ShowDialog();
			if (dr == DialogResult.OK) {
				Properties.Settings.Default.UseEmbeddedFont = dlg.useEmbeddedFont;
				Properties.Settings.Default.PathBoardFont = dlg.fontPath;
				if (!dlg.useEmbeddedFont) {
					if (MbeView.boardFont.ReadFontDataFile(dlg.fontPath)) {
						mbeView.RedrawAll();
						return;
					}
				}
				MbeView.boardFont.SetupEmbeddedFont();
				mbeView.RedrawAll();
			}
		}



		private CanBulkPropResult lastCanBulkPropResult;

		private void OnMenuEditBulkPropOpen(object sender, EventArgs e)
		{
			CanBulkPropResult result = mbeView.Document.CanBulkProperty();
			this.MenuBulkPropHole.Enabled = result.CanPropHole;
			this.MenuBulkPropPTH.Enabled = result.CanPropPTH;
			this.MenuBulkPropPad.Enabled = result.CanPropPad;
			this.MenuBulkPropLine.Enabled = result.CanPropLine;
			this.MenuBulkPropText.Enabled = result.CanPropText;
			this.MenuBulkPropLayer.Enabled = result.CanMoveLayer;
            this.MenuBulkPropPolygon.Enabled = result.CanPropPolygon;
			lastCanBulkPropResult = result;
		}

	

		private void OnBulkPropHole(object sender, EventArgs e)
		{
			mbeView.BulkPropHole();
		}

		private void OnBulkPropPTH(object sender, EventArgs e)
		{
			mbeView.BulkPropPTH();
		}

		private void OnBulkPropPad(object sender, EventArgs e)
		{
			mbeView.BulkPropPad();
		}

		private void OnBulkPropLine(object sender, EventArgs e)
		{
			mbeView.BulkPropLine();
		}

		private void OnBulkPropText(object sender, EventArgs e)
		{
			mbeView.BulkPropText();
		}

        private void OnBulkPropPolygon(object sender, EventArgs e)
        {
            mbeView.BulkPropPolygon();
        }

		private void OnBulkPropLayer(object sender, EventArgs e)
		{
			//MbeObjID id = (lastCanBulkPropResult.CanPropLine ? MbeObjID.MbeLine: MbeObjID.MbeText);
            mbeView.BulkPropLayer(lastCanBulkPropResult);
            //mbeView.BulkPropLayer();
        }

		private void OnFilePrint(object sender, EventArgs e)
		{
			mbeView.Print();
		}

		private void OnFilePrintPreview(object sender, EventArgs e)
		{
			mbeView.PrintPreview();
		}

		private void OnMenuSetConvertFont(object sender, EventArgs e)
		{
			if (!mbeView.Document.CanConvertBoardFont()) return;

			SaveFileDialog saveFileDialog = new SaveFileDialog();

			saveFileDialog.FileName = Properties.Settings.Default.PathBoardFont;
			saveFileDialog.Filter = "MBE board font data (*.dat)|*.dat";
			saveFileDialog.DefaultExt = "dat";
			DialogResult dr = saveFileDialog.ShowDialog();
			if (dr == DialogResult.OK) {
				string path = saveFileDialog.FileName;
				mbeView.Document.ConvertBoardFont(path);
			}
		}

		private void OnOpenMenuSet(object sender, EventArgs e)
		{
			MenuSetConvertFont.Enabled = mbeView.Document.CanConvertBoardFont();
		}

		private void OnMenuFileGerber(object sender, EventArgs e)
		{
			if (DoFileSave()) {

                ExpGerberForm dlg = new ExpGerberForm();
                dlg.LayerMask = Properties.Settings.Default.GerberExportLayer;
                dlg.SelectedDir = Path.GetDirectoryName(mbeView.Document.DocumentPath);
                if (dlg.ShowDialog() != DialogResult.OK) {
                    return;
                }
                Properties.Settings.Default.GerberExportLayer = dlg.LayerMask;
                Properties.Settings.Default.Save();

                ulong exportLayerMask = dlg.LayerMask;
                if (exportLayerMask == 0) {
                    MessageBox.Show("No layers are selected",
                                "Export Gerber",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Stop);
                    return;
                }


#if !MONO
                Cursor.Current = Cursors.WaitCursor;
#endif
				CamOutResult result = mbeView.Document.ExportGerber(dlg.SelectedDir,exportLayerMask);
				switch (result.code) {
					case CamOutResult.ResultCode.FILEERROR:
						{
							string msg = "File write error : " + result.filename;
							MessageBox.Show(msg,
										"Export Gerber", 
										MessageBoxButtons.OK,
										MessageBoxIcon.Stop);
						}
						break;
					case CamOutResult.ResultCode.TCODEOVER:
						MessageBox.Show("T-code exceeded 99.",
									"Export Gerber",
									MessageBoxButtons.OK,
									MessageBoxIcon.Stop);
						break;
					case CamOutResult.ResultCode.DCODEOVER:
						MessageBox.Show("D-code exceeded 999.",
									"Export Gerber",
									MessageBoxButtons.OK,
									MessageBoxIcon.Stop);
						break;
					default:
						MessageBox.Show("Finished Export Gerber.",
									"Export Gerber",
									MessageBoxButtons.OK,
									MessageBoxIcon.Information);
						break;

				}
				mbeView.RedrawAll();
			}
		}

		private void OnMenuFileNetlist(object sender, EventArgs e)
		{
			if (DoFileSave()) {
                ExportFilePathForm dlg = new  ExportFilePathForm();
                dlg.Extension = "net";
                dlg.PathName = Path.ChangeExtension(mbeView.Document.DocumentPath,"net");
                dlg.DlgTitle = "Export Netlist";
                dlg.FileType = "Netlist";
                dlg.FileDlgFilter = "Netlist (*.net)|*.net";

                if (dlg.ShowDialog() != DialogResult.OK) {
                    return;
                }
                
                
                if (mbeView.Document.ExportNetlist(dlg.PathName)) {
                    MessageBox.Show("Finished Export Netlist.",
                                        "Export Netlist",
                                        MessageBoxButtons.OK,
                                        MessageBoxIcon.Information);
                } else {
                    string msg = "File write error";// +result.filename;
                    MessageBox.Show(msg,
                                "Export Netlist",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error);
                }
			}
		}

        private void OnMenuFileComponentPosition(object sender, EventArgs e)
        {
            if (DoFileSave()) {
                ExportFilePathForm dlg = new ExportFilePathForm();
                dlg.Extension = "csv";
                dlg.PathName = Path.ChangeExtension(mbeView.Document.DocumentPath, "csv");
                dlg.DlgTitle = "Export component position";
                dlg.FileType = "CSV file";
                dlg.FileDlgFilter = "Netlist (*.csv)|*.csv";

                if (dlg.ShowDialog() != DialogResult.OK) {
                    return;
                }



                if (mbeView.Document.ExportComponentPosition(dlg.PathName)) {
                    MessageBox.Show("Finished Export Component position list.",
                                    "Component position list",
                                    MessageBoxButtons.OK,
                                    MessageBoxIcon.Information);
                } else {
                    string msg = "File write error";// +result.filename;
                    MessageBox.Show(msg,
                                "Export Component position list",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error);
                }
            }
        }

		private void OnMenuFileDrc(object sender, EventArgs e)
		{
			mbeView.Drc();
		}

		private void OnMenuViewDRC(object sender, EventArgs e)
		{
			mbeView.DisplayDrcMark = !mbeView.DisplayDrcMark;
			mbeView.RedrawAll();
		}

		private void OnMenuViewPolygonFrameMode(object sender, EventArgs e)
		{
#if !MONO
            Cursor.Current = Cursors.WaitCursor;
#endif
            mbeView.SetViewPolygonFrameOnly(!MbeView.ViewPolygonFrame);
			//mbeView.RedrawAll();
		}

		private void OnOpenMenuView(object sender, EventArgs e)
		{
			MenuViewDRC.Checked = mbeView.DisplayDrcMark;
			MenuViewPolygonFrameMode.Checked = MbeView.ViewPolygonFrame;
		}

		private void OnMenuEditUpdateFillPolygon(object sender, EventArgs e)
		{
#if !MONO
            Cursor.Current = Cursors.WaitCursor;
#endif
            mbeView.FillPolygon();
		}

		private void OnMenuEditRedo(object sender, EventArgs e)
		{
			mbeView.Document.Redo();
			mbeView.RedrawAll();
		}


		private void SaveWindowState()
		{
			FormWindowState ws = this.WindowState;
            if (ws == FormWindowState.Minimized) return;//ŏ̂Ƃ̓EBhEXe[gۑȂ
			Properties.Settings.Default.MainWindowState = (ws == FormWindowState.Maximized ? 1 : 0);
			Properties.Settings.Default.MainWindowWidth = Size.Width;
			Properties.Settings.Default.MainWindowHeight = Size.Height;
		}

		private void OnSizeChanged(object sender, EventArgs e)
		{
			SaveWindowState();
		}

		private void OnFilePageSetup(object sender, EventArgs e)
		{
			SetupPageForm dlg = new SetupPageForm();
			dlg.PrintLeftMargin = mbeView.PrintLeftMargin;
			dlg.PrintBottomMargin = mbeView.PrintBottomMargin;
            dlg.Print2xMode = mbeView.Print2xMode;
            dlg.PrintCurrentView = Properties.Settings.Default.PrintCurrentView;
            dlg.CenterPunchMode = mbeView.CenterPunchMode;
            dlg.PrintToolMarkMode = mbeView.PrintToolMarkMode;
            dlg.PrintToolMarkModeEnable = (MbeView.toolMarkLib != null);
            dlg.PrintColorMode = mbeView.PrintColorMode;
            
			DialogResult retv = dlg.ShowDialog();
			if (retv == DialogResult.OK) {
				mbeView.PrintLeftMargin = dlg.PrintLeftMargin;
				mbeView.PrintBottomMargin = dlg.PrintBottomMargin;
                mbeView.Print2xMode = dlg.Print2xMode;
                mbeView.CenterPunchMode = dlg.CenterPunchMode;
                mbeView.PrintToolMarkMode = dlg.PrintToolMarkMode;
                mbeView.PrintColorMode = dlg.PrintColorMode;

				Properties.Settings.Default.PrintLeftMargin = dlg.PrintLeftMargin;
				Properties.Settings.Default.PrintBottomMargin = dlg.PrintBottomMargin;
                Properties.Settings.Default.Print2xMode = dlg.Print2xMode;
                Properties.Settings.Default.CenterPunchMode = dlg.CenterPunchMode;
                Properties.Settings.Default.ToolMarkPrint = dlg.PrintToolMarkMode;
                Properties.Settings.Default.PrintColorMode = (uint)dlg.PrintColorMode;
                Properties.Settings.Default.PrintCurrentView = dlg.PrintCurrentView;
			}
		}

		private void OnMenuFileBitmap(object sender, EventArgs e)
		{
			mbeView.ExportImage();
		}

        private void OnMenuSetLibrary(object sender, EventArgs e)
        {
            SetLibForm dlg = new SetLibForm();
            if (dlg.ShowDialog() == DialogResult.OK) {
                //componentLibrary.LoadLibraries(dlg.LibPathNameArray);
                LoadLibraries();
            }

        }

        private void LoadLibraries()
        {
            string strMyStdInfo = Properties.Settings.Default.MyStandardLibString;
            MbeMyStd[] myStdInfoArray = MbeMyStd.LoadMyStdInfoArray(strMyStdInfo);
            int count = myStdInfoArray.Length;
            string[] pathNameArray = new string[count];
            for (int i = 0; i < count; i++) {
                pathNameArray[i] = ((LibInfo)myStdInfoArray[i]).LibPath;
            }

            componentLibrary.LoadLibraries(pathNameArray);
            TBarComponent.Enabled = (componentLibrary.LibCount > 0);

        }

        private void OnMenuSetToolMarkFile(object sender, EventArgs e)
        {
            string path = Properties.Settings.Default.ToolMarkFile;
            if ((path.Length > 0) && (!Path.IsPathRooted(path))) {
                string appPath = Application.ExecutablePath;
                appPath = Path.GetDirectoryName(appPath);
                path = Path.Combine(appPath, path);
            }
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.InitialDirectory = Path.GetDirectoryName(path);
            openFileDialog.FileName = Path.GetFileName(path);
            openFileDialog.Filter = "MBE data file (*.mb3)|*.mb3";
            openFileDialog.DefaultExt = "mb3";
            DialogResult dr = openFileDialog.ShowDialog();
            if (dr == DialogResult.OK) {
                Properties.Settings.Default.ToolMarkFile = openFileDialog.FileName;
                Properties.Settings.Default.Save();
                LoadToolMark();
            }
        }

        private bool LoadToolMark()
        {
            MbeView.toolMarkLib = null;
      
            string path = Properties.Settings.Default.ToolMarkFile;
            if ((path.Length > 0) && (!Path.IsPathRooted(path))) {
                string appPath = Application.ExecutablePath;
                appPath = Path.GetDirectoryName(appPath);
                path = Path.Combine(appPath, path);
            }

            if (path.Length == 0) return false;
            MbeView.toolMarkLib = new MbeLib();
            if (!MbeView.toolMarkLib.LoadLibrary(path)) {
                MbeView.toolMarkLib = null;
                return false;
            }
            return true;
        }

        //0.48.04 hbOhbv
        //CtH[̃vpeBAllowDroptrueɂ邱
        //hbOĂ
        private void MainForm_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) {
                e.Effect = DragDropEffects.All;
            } else {
                e.Effect = DragDropEffects.None;
            }
        }
        //hbv
        private void MainForm_DragDrop(object sender, DragEventArgs e)
        {
            string[] s = (string[])e.Data.GetData(DataFormats.FileDrop, false);
            int i;
            for (i = 0; i < s.Length; i++) {
                DoFileOpen(s[i]);
            }
        }


    }


}