using System;
using System.Drawing;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace mbe
{
	class MbeNetOut
	{
		public MbeNetOut()
		{
			workList = new LinkedList<MbeObj>();
			conChk = new MbeConChk();

		}

		/// <summary>
		/// AOtH[}bgŏo͂B
		/// </summary>
		/// <param name="filename"></param>
		/// <returns></returns>
		public bool DoExport(string filename, LinkedList<MbeObj> mbeList)
		{

			SetMbeObjData(mbeList);

			LinkedList<MbeObj> objList = new LinkedList<MbeObj>();

			int netNum = 0;
			bool result = true;

			StreamWriter streamWriter = null;
			try {
				streamWriter = new StreamWriter(filename);
				streamWriter.WriteLine("$NETS");
				while (GetNet(objList, true)) {
					if (objList.Count < 2) continue;
					netNum++;
					string netName = String.Format("N{0:00000};  ", netNum);
					streamWriter.Write(netName);
					int nodeCount = 0;
					foreach(MbeObj obj in objList){
						if (nodeCount > 0 && nodeCount % 5 == 0) {
							streamWriter.WriteLine(" ,");
							streamWriter.Write("    ");
						}
						streamWriter.Write(" "+obj.TempPropString + "."+((MbeObjPin)obj).PinNum);
						nodeCount++;
					}
					streamWriter.WriteLine();
				}
				streamWriter.WriteLine("$END");
			}
			catch (Exception) {
				result = false;
			}
			finally {
				if (streamWriter != null) {
					streamWriter.Close();
				}
			}
			CleanUp();
			return result;
		}


		/// <summary>
		/// lbgXg쐬ɕύX}ʗvf̃o[NA
		/// </summary>
		public void CleanUp()
		{
			if (workList.Count > 0) {
				foreach (MbeObj obj in workList) {
					obj.ClearConnectCheck();
					obj.TempPropString = "";
					obj.ClearDeleteCount();
				}
				workList.Clear();
			}
		}

		/// <summary>
		/// lbgXgɕKvȐ}ʗvf𒊏o workList ɓ
		/// </summary>
		/// <param name="mbeList"></param>
		/// <returns></returns>
		public bool SetMbeObjData(LinkedList<MbeObj> mbeList)
		{
			CleanUp();
			foreach (MbeObj obj in mbeList) {
				if (obj.DeleteCount >= 0) continue;

				if (obj.Id() == MbeObjID.MbeLine ||
					obj.Id() == MbeObjID.MbeArc ||
                    obj.Id() == MbeObjID.MbePTH ||
                    obj.Id() == MbeObjID.MbePinSMD) {
					if (obj.Layer == MbeLayer.LayerValue.CMP ||
                        obj.Layer == MbeLayer.LayerValue.L2 ||
                        obj.Layer == MbeLayer.LayerValue.L3 ||
						obj.Layer == MbeLayer.LayerValue.SOL ||
						obj.Layer == MbeLayer.LayerValue.PTH) {
						workList.AddLast(obj);
					}
					continue;
				}
				
				if (obj.Id() == MbeObjID.MbeComponent) {
					foreach (MbeObj objContent in ((MbeObjComponent)obj).ContentsObj) {
						if (objContent.Layer != MbeLayer.LayerValue.CMP &&
                            objContent.Layer != MbeLayer.LayerValue.L2 &&
                            objContent.Layer != MbeLayer.LayerValue.L3 &&
							objContent.Layer != MbeLayer.LayerValue.SOL &&
							objContent.Layer != MbeLayer.LayerValue.PTH) continue;
						if (objContent.Id() == MbeObjID.MbeLine ||
                            objContent.Id() == MbeObjID.MbeArc) {
							workList.AddLast(objContent);
						} else if (objContent.Id() == MbeObjID.MbePTH ||
								  objContent.Id() == MbeObjID.MbePinSMD) {
							objContent.TempPropString = ((MbeObjComponent)obj).RefNumText;
							workList.AddLast(objContent);
						}
					}
					continue;
				}
			}
			return workList.Count > 0;
		}


		/// <summary>
		/// workListЂƂ̃lbgobjListNetɎo
		/// </summary>
		/// <param name="objListNet"></param>
		/// <param name="pinOnly">lbgo̓XgɃs񂾂ԂƂtrue</param>
		/// <returns>ЂƂm[hȂꍇfalseԂ</returns>
		public bool GetNet(LinkedList<MbeObj> objListNet,bool pinOnly)
		{
			//ЂƂ̃lbg̋N_ɂȂsIяo
			objListNet.Clear();
			MbeObj obj = null;
			foreach (MbeObj _obj in workList) {
				//łConnectionCheckActivetỐAlbgƂĒoς
				if (_obj.ConnectionCheckActive) continue;

				if (_obj.Id() == MbeObjID.MbePTH ||
					_obj.Id() == MbeObjID.MbePinSMD) {
					//if (_obj.TempPropString.Length > 0) {
						obj = _obj;
						break;
					//}
				}
			}
			if(obj==null) return false;

			conChk.Clear();

			//objN_ɂāAڑĂ̂ ConnectionCheckActive LɂB
			conChk.ScanData(obj, workList);

			//ConnectionCheckActive LŁA_obj.DeleteCount -2łȂ̂o̓Xgɖo^B
			foreach (MbeObj _obj in workList) {
				if (_obj.ConnectionCheckActive && _obj.DeleteCount != -2) {
					_obj.DeleteCount = -2;
					if (pinOnly) {
						if (_obj.Id() == MbeObjID.MbePTH ||
						   _obj.Id() == MbeObjID.MbePinSMD) {
							if (_obj.TempPropString.Length > 0) {
								objListNet.AddLast(_obj);
							}
						}
					} else {
						objListNet.AddLast(_obj);
					}
				}
			}
			return true;
		}

		public LinkedList<MbeObj> workList;
		protected MbeConChk conChk;
	}
}
