using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Collections.Generic;
using System.Text;

using CE3IO;

namespace mbe
{
	public abstract class MbeObjPin : MbeObj
	{
		protected static readonly string[] padShapeName = {
			"RECT",
			"OBROUND"	//ǉꍇłOBROUNDɍŌɂȂ悤ɂB
		};

		public enum PadShape
		{
			ERR = -1,
			Rect,
			Obround	//ǉꍇłObroundɍŌɂȂ悤ɂB
		}

        /// <summary>
        /// T[}[t̎
        /// </summary>
        protected static readonly string[] thermalReliefTypeName = {
           "THMLRLFINCOMP",//iƂT[}[tƂ
           "SOLID"         //Ƀ\bhڑ
        };



        /// <summary>
        /// T[}[t̎
        /// </summary>
        public enum PadThermalRelief
        {
            ERR = -1,
            ThmlRlfInComp,       //iƂT[}[tƂ
            Solid                //Ƀ\bhڑ
        }

		public const int MIN_PAD_SIZE =   2000; //0.2mm
		public const int MAX_PAD_SIZE = 100000; //10mm


        public PadThermalRelief ThermalRelief
        {
            get { return thermalRelief; }
            set { thermalRelief = value; }
        }


		/// <summary>
		/// \_WXg̃}[Wl
		/// </summary>
		protected const int DEFAULT_SRMARGIN = 1000; //0.1mm

		/// <summary>
		/// \_WXg̃}[Wől
		/// </summary>
		protected const int MAX_SRMARGIN = 10000; //1.0mm

		/// <summary>
		/// \_WXg̃}[Wŏl
		/// </summary>
		protected const int MIX_SRMARGIN = -1000; //-0.1mm

        public const int DEFAULT_WIDTH = 16000;
        public const int DEFAULT_HEIGHT = 16000;

		/// <summary>
		/// PadShapelɑΉpbh`󖼂𓾂
		/// </summary>
		/// <param name="layer"></param>
		/// <returns></returns>
		public static string GetPadShapeName(PadShape shape)
		{
			if (shape == PadShape.ERR) {
				return "";
			}
			return padShapeName[(int)shape];
		}

		/// <summary>
		/// name ɑΉ PadShapeԂB
		/// </summary>
		/// <param name="name"></param>
		/// <returns></returns>
		public static PadShape GetPadShapeValue(string name)
		{
			int namesCount = padShapeName.Length;
			for (int i = 0; i < namesCount; i++) {
				if (padShapeName[i] == name) {
					return (PadShape)i;
				}
			}
			return PadShape.ERR;
		}

        /// <summary>
        /// thmlrlf lɑΉT[}[t^CvԂ
        /// </summary>
        /// <param name="thmlrlf"></param>
        /// <returns></returns>
        public static string GetThermalReliefTypeName(PadThermalRelief thmlrlf)
		{
			if (thmlrlf == PadThermalRelief.ERR) {
				return "";
			}
			return thermalReliefTypeName[(int)thmlrlf];
		}

        /// <summary>
        /// T[}[tɑΉlԂ
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public static PadThermalRelief GetThermalReliefTypeValue(string name)
        {
            int namesCount = thermalReliefTypeName.Length;
			for (int i = 0; i < namesCount; i++) {
				if (thermalReliefTypeName[i] == name) {
					return (PadThermalRelief)i;
				}
			}
			return PadThermalRelief.ERR;
        }





		protected Size padSize;
		protected PadShape shape;
		protected int srmargin;
		protected string num;
        private PadThermalRelief thermalRelief;


		
				

		/// <summary>
		/// RXgN^
		/// </summary>
		protected MbeObjPin()
		{
			posCount = 1;
			posArray = new Point[posCount];
			selectFlag = new bool[posCount];
			selectFlag[0] = false;

			//padSize = new Size(DEFAULT_WIDTH, DEFAULT_HEIGHT);
			//shape = PadShape.Obround;
			srmargin = DEFAULT_SRMARGIN;
			num = "";
            thermalRelief = PadThermalRelief.ThmlRlfInComp;
		}

		/// <summary>
		/// Rs[RXgN^
		/// </summary>
		/// <param name="mbeObjPin"></param>
		protected MbeObjPin(MbeObjPin mbeObjPin)
			: base(mbeObjPin)
		{
			padSize = mbeObjPin.padSize;
			shape = mbeObjPin.shape;
			srmargin = mbeObjPin.srmargin;
			num = mbeObjPin.num;
            thermalRelief = mbeObjPin.thermalRelief;
		}


		/// <summary>
		/// ]
		/// </summary>
		/// <param name="selectedOnly"></param>
		/// <param name="ptCenter"></param>
		public override void Rotate90(bool selectedOnly, Point ptCenter)
		{
			base.Rotate90(selectedOnly, ptCenter);
			int w = padSize.Width;
			int h = padSize.Height;
			padSize = new Size(h, w);
		}
		

		/// <summary>
		/// pbhTCY̎擾Ɛݒ
		/// </summary>
		public Size PadSize
		{
			get
			{
				return padSize;
			}
			set
			{
				padSize = value;
			}
		}

		/// <summary>
		/// pbh̎̕擾Ɛݒ
		/// </summary>
		public int Width
		{
			get
			{
				return padSize.Width;
			}
			set
			{
				if (value < 0) value = 0;
				padSize.Width = value;
			}
		}

		/// <summary>
		/// pbh̍̎擾Ɛݒ
		/// </summary>
		public int Height
		{
			get
			{
				return padSize.Height;
			}
			set
			{
				if (value < 0) value = 0;
				padSize.Height = value;
			}
		}

		/// <summary>
		///  pbh`̎擾Ɛݒ
		/// </summary>
		public PadShape Shape
		{
			get
			{
				return shape;
			}
			set
			{
				if ((int)value < 0 || (int)value > (int)PadShape.Obround) {
					value = PadShape.Obround;
				}
				shape = value;
			}
		}

		/// <summary>
		/// sԍ̎擾Ɛݒ
		/// </summary>
		public string PinNum
		{
			get
			{
				return num;
			}
			set
			{
				num = value;
			}
		}

		/// <summary>
		/// \_WXg}[W̐ݒ
		/// </summary>
		public int SrMargin
		{
			get { return srmargin; }
			set
			{
				srmargin = value;
				if (srmargin < MIX_SRMARGIN) srmargin = MIX_SRMARGIN;
				else if (srmargin > MAX_SRMARGIN) srmargin = MAX_SRMARGIN;
			}
		}


		/// <summary>
		/// Is
		/// </summary>
		/// <param name="rc"></param>
		/// <param name="layerMask"></param>
		/// <param name="pointMode"></param>
		/// <returns>IΏۂƂtrueԂ</returns>
		/// <remarks>
		/// IΏۂꍇɂ͑ItOZbgB
		/// </remarks>
		public override bool SelectIt(MbeRect rc, ulong layerMask, bool pointMode)
		{
			if ((layerMask & (ulong)layer) == 0) return false;
			if (DeleteCount >= 0) return false;

			if (!pointMode) {
				return base.SelectIt(rc, layerMask, pointMode);
			}

			int areaWidth = 0;
			int areaHeight = 0;
			Point ptC = rc.Center();

			//܂Apbh̋`͈͓ɓĂ邩ǂ̃`FbN
			//~pbhł́A[̔~GA`FbN
			if (Shape == PadShape.Obround) {
				if (Height < Width) {
					areaHeight = Height;
					areaWidth = Width - Height;
				} else if (Height > Width) {
					areaHeight = Height - Width;
					areaWidth = Width;
				} else {
					//ƍꍇ́A`GA݂ȂB
					//S_猟_܂ł̋aɎ܂Ă邩ǂ̃`FbN
					if(Util.DistancePointPoint(ptC,GetPos(0))<=Width/2){
						selectFlag[0] = true;
						return true;
					}else{
						return false;
					}
				}
			} else {	//`pbhȂ`pbhŜł
				areaHeight = Height;
				areaWidth = Width;
			}

			int x = GetPos(0).X;
			int y = GetPos(0).Y;
			int l = x - areaWidth / 2;
			int r = x + areaWidth / 2;
			int t = y + areaHeight / 2;
			int b = y - areaHeight / 2;


			//`GA`FbN
			if (l <= ptC.X && ptC.X <= r && b <= ptC.Y && ptC.Y < t) {
				selectFlag[0] = true;
				return true;
			}

			//~̏ꍇ́A[~`FbNsB
			if (Shape == PadShape.Obround) {
				int x0 = 0;
				int y0 = 0;
				int x1 = 0;
				int y1 = 0;
				int rad = 0;	//a
				if (Height < Width) {
					rad = Height /2;
					x0 = l;
					x1 = r;
					y0 = y1 = y;
				}else if(Height > Width){
					rad = Width /2;
					x0 = x1 = x;
					y0 = b;
					y1 = t;
				}
				if( Util.DistancePointPoint(ptC,new Point(x0,y0))<=rad ||
					Util.DistancePointPoint(ptC,new Point(x1,y1))<=rad){
					selectFlag[0] = true;
					return true;
				}
			}

			return false;
		}

		/// <summary>
		/// |Ŝ߂̗֊sf[^𐶐B
		/// </summary>
		/// <param name="outlineList"></param>
		/// <param name="param"></param>
		/// <remarks>Ő֊sf[^͓ɏdȂĂĂǂ̂Ƃ</remarks>
		public override void GenerateOutlineData(LinkedList<MbeGapChkObjLine> outlineList, GenOutlineParam param)
		{
			//if (param.layer != Layer) return;
			int distance;
			Point ptCenter = GetPos(0);
			Point[] pt;
			int pointCount;
			int x = ptCenter.X;
			int y = ptCenter.Y;


			if (shape == PadShape.Rect) {
				distance = param.traceWidth / 2 + param.gap;
				pt = new Point[4];
				pointCount = 4;
				int xoffset = Width / 2 + distance;
				int yoffset = Height / 2 + distance;
				pt[0] = new Point(x - xoffset, y + yoffset);
				pt[1] = new Point(x + xoffset, y + yoffset);
				pt[2] = new Point(x + xoffset, y - yoffset);
				pt[3] = new Point(x - xoffset, y - yoffset);

			} else {
				int lineW;
				int lineL;
				Point pt0;
				Point pt1;
				if (Width < Height) {
					lineW = Width;
					lineL = Height - lineW;
					pt0 = new Point(x, y - lineL / 2);
					pt1 = new Point(x, y + lineL / 2);
				} else {
					lineW = Height;
					lineL = Width - lineW;
					pt0 = new Point(x - lineL / 2, y);
					pt1 = new Point(x + lineL / 2, y);
				}

				distance = (lineW + param.traceWidth) / 2 + param.gap*11/10;

				int left = param.rc.L - distance;
				int top = param.rc.T + distance;
				int right = param.rc.R + distance;
				int bottom = param.rc.B - distance;

				MbeRect rcArea = new MbeRect(new Point(left, top), new Point(right, bottom));

				if (Util.LineIsOutsideLTRB(pt0, pt1, rcArea)) {
					return;
				}
				bool dummyParam;
				Util.LineOutlineData(pt0, pt1, distance, out pt, out dummyParam);
				pointCount = 8;
			}

			for (int j = 0; j < pointCount; j++) {
				int j2 = j + 1;
				if (j2 == pointCount) {
					j2 = 0;
				}
				if (!Util.LineIsOutsideLTRB(pt[j], pt[j2], param.rc)) {
					MbeGapChkObjLine objLine = new MbeGapChkObjLine();
					objLine.SetLineValue(pt[j], pt[j2], param.traceWidth);
					outlineList.AddLast(objLine);
				}
			}
		}



		/// <summary>
		/// ConChk̂߂̎̎擾
		/// </summary>
		/// <param name="rc"></param>
		/// <param name="layerMask"></param>
		/// <returns></returns>
		public override MbeObj ConChkSeed(MbeRect rc, ulong layerMask)
		{
			if (SelectIt(rc, layerMask, true)) {
				ClearAllSelectFlag();
				return this;
			}
			return null;
		}

		/// <summary>
		/// Mb3t@C̓ǂݍݎ̃o[̉߂s
		/// </summary>
		/// <param name="str1">ϐ܂"+"Ŏn܂ubN^O</param>
		/// <param name="str2">ϐl</param>
		/// <param name="readCE3">ubNǂݍݎɎgReadCE3NX</param>
		/// <returns>IReadCE3.RdStatus.NoErrorԂ</returns>
		public override ReadCE3.RdStatus RdMb3Member(string str1, string str2, ReadCE3 readCE3)
		{
			switch(str1){
				case  "HEIGHT":
					try { Height = Convert.ToInt32(str2);}
					catch (Exception) { Height = DEFAULT_HEIGHT; }
					return ReadCE3.RdStatus.NoError;
				case "WIDTH":
					try { Width = Convert.ToInt32(str2); }
					catch (Exception) { Width = DEFAULT_WIDTH;}
					return ReadCE3.RdStatus.NoError;
				case "SHAPE":
					shape = GetPadShapeValue(str2);
                    if (shape == PadShape.ERR) {
                        shape = PadShape.Obround;
                    }
					return ReadCE3.RdStatus.NoError;
                case "THMLRLF":
                    thermalRelief = GetThermalReliefTypeValue(str2);
                    if (thermalRelief == PadThermalRelief.ERR) {
                        thermalRelief = PadThermalRelief.ThmlRlfInComp;
                    }
                    return ReadCE3.RdStatus.NoError;
                case "PINNUM":
					PinNum = ReadCE3.DecodeCE3String(str2);
					return ReadCE3.RdStatus.NoError;
				case "SRMARGIN":
					try { SrMargin = Convert.ToInt32(str2); }
					catch (Exception) { SrMargin = DEFAULT_SRMARGIN; }
					return ReadCE3.RdStatus.NoError;
				default:
					return base.RdMb3Member(str1, str2, readCE3);
			}
			//return true;
		}

		
		/// <summary>
		/// WriteCE3NXփo[̏
		/// </summary>
		/// <param name="writeCE3">ݑΏWriteCE3NX</param>
		/// <param name="origin">ݎ̌_</param>
		/// <returns>Itrue</returns>
		public override bool WrMb3Member(WriteCE3 writeCE3, Point origin)
		{
			base.WrMb3Member(writeCE3, origin);
			writeCE3.WriteRecordInt("HEIGHT", Height);
			writeCE3.WriteRecordInt("WIDTH", Width);
			writeCE3.WriteRecordString("SHAPE", GetPadShapeName(shape));
            writeCE3.WriteRecordString("THMLRLF", GetThermalReliefTypeName(thermalRelief));
			writeCE3.WriteRecordString("PINNUM", PinNum);
			writeCE3.WriteRecordInt("SRMARGIN", SrMargin);
			return true;
		}

		

		/// <summary>
		/// sԍ̕`
		/// </summary>
		/// <param name="g">`Ώ</param>
		/// <param name="str"></param>
		/// <param name="pt">ʒu(ɃZ^O)</param>
		/// <param name="fontSize">tHg̃sNZTCY</param>
		/// <param name="vertical">ɕ`悷Ƃtrue</param>
		protected virtual void DrawPinNum(Graphics g, string str, Point pt, int fontSize, bool vertical)
		{
			if (fontSize < 10 || str.Length == 0) return;
			Font font = new Font(FontFamily.GenericSerif, fontSize, GraphicsUnit.Pixel);
			Brush brush = new SolidBrush(MbeColors.ColorPinNum);
			StringFormat format = new StringFormat(StringFormatFlags.NoClip);
			format.Alignment = StringAlignment.Center;
			format.LineAlignment = StringAlignment.Center;

			//͍Wn𕽍sړĂ`悷
			GraphicsState gState = g.Save();	//Wnۑ
			g.TranslateTransform(pt.X, pt.Y);
			if (vertical) {						//]
				g.RotateTransform(-90F);
			}
			g.DrawString(str, font, brush, new PointF(0, 0),format);
			g.Restore(gState);					//WnA

			format.Dispose();
			brush.Dispose();
			font.Dispose();
		}

		/// <summary>
		/// ڑ`FbÑANeBuԂ̐ݒ
		/// </summary>
		public override void SetConnectCheck()
		{
			connectionCheckActive = true;
		}

        /// <summary>
        /// `͈͂𓾂
        /// </summary>
        /// <returns></returns>
        public override MbeRect OccupationRect()
        {
			
			int x = GetPos(0).X;
			int y = GetPos(0).Y;
			int l = x - Width / 2;
			int r = x + Width / 2;
			int t = y + Height / 2;
			int b = y - Height / 2;

            return new MbeRect(new Point(l, t), new Point(r, b));
        }

	}
}
