using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;



using CE3IO;

namespace mbe
{
	public class MbeObjText : MbeObj
	{
		public const int MIN_LINE_WIDTH = 1500;
		public const int MAX_LINE_WIDTH = 10000;
		public const int DEFAULT_LINE_WIDTH = 2540;	//10mil
		public const int MIN_TEXT_HEIGHT = 10000;
		public const int MAX_TEXT_HEIGHT = 100000;
		public const int DEFAULT_TEXT_HEIGHT = 20000;

		/// <summary>
		/// C̐ݒƎ擾 
		/// </summary>
		public int LineWidth
		{
			get { return lineWidth; }
			set
			{
				lineWidth = value;
				if (lineWidth < MIN_LINE_WIDTH) lineWidth = MIN_LINE_WIDTH;
				else if (lineWidth > MAX_LINE_WIDTH) lineWidth = MAX_LINE_WIDTH;
			}
		}

		/// <summary>
		/// ̐ݒƎ擾
		/// </summary>
		public int TextHeight
		{
			get { return textHeight; }
			set 
			{ 
				textHeight = value;
				if (textHeight < MIN_TEXT_HEIGHT) textHeight = MIN_TEXT_HEIGHT;
				else if (textHeight > MAX_TEXT_HEIGHT) textHeight = MAX_TEXT_HEIGHT;
			}
		}

		/// <summary>
		/// ݒ
		/// </summary>
		//public bool Vertical
		//{
		//    set { vertical = value; }
		//    get { return vertical; }
		//}

		public int Dir
		{
			get { return dir; }
			set
			{
				dir = value % 360;
				if (dir < 0) dir += 360;
			}
		}



		///// <summary>
		///// ̐ݒƎ擾
		///// </summary>
		//public string Text
		//{
		//    set { text = value; }
		//    get { return text; }
		//}

		/// <summary>
		/// RXgN^
		/// </summary>
		public MbeObjText()
		{
			posCount = 1;
			posArray = new Point[posCount];
			selectFlag = new bool[posCount];
			selectFlag[0] = false;

			lineWidth = DEFAULT_LINE_WIDTH;
			textHeight = DEFAULT_TEXT_HEIGHT;
			dir = 0;
			//vertical = false;
			//text = "";
		}

		/// <summary>
		/// Rs[RXgN^
		/// </summary>
		/// <param name="mbeObjPin"></param>
		public MbeObjText(MbeObjText mbeObjText)
			: base(mbeObjText)
		{
			lineWidth = mbeObjText.lineWidth;
			textHeight = mbeObjText.textHeight;
			Dir = mbeObjText.dir;
			//vertical = mbeObjText.vertical;
			//text = mbeObjText.text;
		}

		/// <summary>
		/// LǂԂ
		/// </summary>
		/// <returns></returns>
		public override bool IsValid()
		{
			if (signame.Length == 0) return false;
			return true;
		}

		/// <summary>
		/// }ʃIuWFNgƂIDlԂ
		/// </summary>
		public override MbeObjID Id()
		{
			return MbeObjID.MbeText;
		}

		/// <summary>
		/// C[l̎擾Ɛݒ
		/// </summary>
		public override MbeLayer.LayerValue Layer
		{
			get
			{
				return layer;
			}
			set
			{
				if ((SelectableLayer() & (ulong)value) != 0) {
					layer = value;
				} else {
					layer = MbeLayer.LayerValue.DOC;
				}
				snapLayer = (ulong)layer;
			}
		}


		/// <summary>
		/// zuw\ȃC[
		/// </summary>
		/// <returns></returns>
		public static ulong SelectableLayer()
		{
			return (ulong)MbeLayer.LayerValue.PLC |
					(ulong)MbeLayer.LayerValue.PLS |
					(ulong)MbeLayer.LayerValue.STC |
					(ulong)MbeLayer.LayerValue.STS |
					(ulong)MbeLayer.LayerValue.CMP |
                    (ulong)MbeLayer.LayerValue.L2  |
                    (ulong)MbeLayer.LayerValue.L3  |
                    (ulong)MbeLayer.LayerValue.SOL |
					(ulong)MbeLayer.LayerValue.DIM |
					(ulong)MbeLayer.LayerValue.DOC;
		}

		public static MbeLayer.LayerValue NewSelectLayer(MbeLayer.LayerValue oldLayer)
		{
			if ((SelectableLayer() & (ulong)oldLayer) != 0) {
				return oldLayer;
			} else {
				if (MbeLayer.IsComponentSide(oldLayer)) {
					return MbeLayer.LayerValue.PLC;
				} else {
					return MbeLayer.LayerValue.PLS;
				}
			}
		}

		/// <summary>
		/// Mb3t@C̓ǂݍݎ̃o[̉߂s
		/// </summary>
		/// <param name="str1">ϐ܂"+"Ŏn܂ubN^O</param>
		/// <param name="str2">ϐl</param>
		/// <param name="readCE3">ubNǂݍݎɎgReadCE3NX</param>
		/// <returns>IReadCE3.RdStatus.NoErrorԂ</returns>
		public override ReadCE3.RdStatus RdMb3Member(string str1, string str2, ReadCE3 readCE3)
		{
			switch (str1) {
				case "WIDTH":
					try { LineWidth = Convert.ToInt32(str2); }
					catch (Exception) { LineWidth = DEFAULT_LINE_WIDTH; }
					return ReadCE3.RdStatus.NoError;
				case "HEIGHT":
					try { TextHeight = Convert.ToInt32(str2); }
					catch (Exception) { TextHeight = DEFAULT_TEXT_HEIGHT; }
					return ReadCE3.RdStatus.NoError;
				case "DIR": 
					{
						//int n = 0;
						try { Dir = Convert.ToInt32(str2); }
						catch (Exception) { Dir = 0; }
						//Vertical = (n != 0);
						return ReadCE3.RdStatus.NoError;
					}

				default:
					return base.RdMb3Member(str1, str2, readCE3);
			}
		}


		/// <summary>
		/// ̃NXMb3t@C̓ǂݍ
		/// </summary>
		/// <param name="readCE3">ǂݍݑΏۂReadCE3NX</param>
		/// <returns>IReadCE3.RdStatus.NoError Ԃ</returns>
		public override ReadCE3.RdStatus RdMb3(ReadCE3 readCE3)
		{
			string str1;
			string str2;
			while (readCE3.GetRecord(out str1, out str2)) {
				if (str1[0] == '-') {
					if (str1 != "-MBE_TEXT") {
						return ReadCE3.RdStatus.FormatError;
					} else {
						return ReadCE3.RdStatus.NoError;
					}
				} else {
					ReadCE3.RdStatus result = RdMb3Member(str1, str2, readCE3);
					if (result != ReadCE3.RdStatus.NoError) {
						return result;
					}
				}
			}
			return ReadCE3.RdStatus.FileError;
		}

		/// <summary>
		/// WriteCE3NXփo[̏
		/// </summary>
		/// <param name="writeCE3">ݑΏWriteCE3NX</param>
		/// <param name="origin">ݎ̌_</param>
		/// <returns>Itrue</returns>
		public override bool WrMb3Member(WriteCE3 writeCE3, Point origin)
		{
			base.WrMb3Member(writeCE3, origin);
			writeCE3.WriteRecordInt("WIDTH", LineWidth);
			writeCE3.WriteRecordInt("HEIGHT",TextHeight);
			writeCE3.WriteRecordInt("DIR", Dir);
			//writeCE3.WriteRecordInt("DIR", (Vertical ? 90:0));
			return true;
		}

		/// <summary>
		/// ]
		/// </summary>
		/// <param name="selectedOnly"></param>
		/// <param name="ptCenter"></param>
		public override void Rotate90(bool selectedOnly, Point ptCenter)
		{
			base.Rotate90(selectedOnly, ptCenter);
			Dir = dir + 90;
			//vertical = !vertical;
		}


        
        /// <summary>
        /// Flip̃oÕpb`B
        /// </summary>
        /// <param name="hCenter"></param>
        public override void Flip(int hCenter)
        {
            base.Flip(hCenter);
            int angle = dir % 360;
            Dir = 360 - angle;
        }


		/// <summary>
		/// Mb3t@Cւ̏
		/// </summary>
		/// <param name="writeCE3"></param>
		/// <returns></returns>
		public override bool WrMb3(WriteCE3 writeCE3, Point origin)
		{
			writeCE3.WriteRecord("+MBE_TEXT");
			WrMb3Member(writeCE3, origin);
			writeCE3.WriteRecord("-MBE_TEXT");
			writeCE3.WriteNewLine();
			return true;
		}

		/// <summary>
		/// s
		/// </summary>
		/// <returns></returns>
		public override MbeObj Duplicate()
		{
			MbeObj newObj = new MbeObjText(this);
			return newObj;
		}

		/// <summary>
		/// `
		/// </summary>
		/// <param name="dp"></param>
		public override void Draw(DrawParam dp)
		{
			if (dp.layer != Layer) {
				return;
			}
			Point pt0 = this.GetPos(0);
			pt0 = ToDrawDim(pt0, dp.scale);

			Color col;
			int w = 0;
			int h = 0;
			//bool reverse = false;

			//`敝̐ݒ
			w = (int)(LineWidth / dp.scale) | 1;

			//`敶̐ݒ
			h = (int)(TextHeight / dp.scale);

			if (dp.mode == MbeDrawMode.Print) {
                if ((dp.option & (uint)MbeDrawOption.PrintColor) != 0) {    //J[
                    uint nColor;
                    switch (dp.layer) {
                        case MbeLayer.LayerValue.PLC:
                            nColor = MbeColors.PRINT_PLC;
                            break;
                        case MbeLayer.LayerValue.PLS:
                            nColor = MbeColors.PRINT_PLS;
                            //reverse = true;
                            break;
                        case MbeLayer.LayerValue.STC:
                            nColor = MbeColors.PRINT_STC;
                            break;
                        case MbeLayer.LayerValue.STS:
                            nColor = MbeColors.PRINT_STS;
                            //reverse = true;
                            break;
                        case MbeLayer.LayerValue.CMP:
                            nColor = MbeColors.PRINT_CMP;
                            break;
                        case MbeLayer.LayerValue.L2:
                            nColor = MbeColors.PRINT_L2;
                            break;
                        case MbeLayer.LayerValue.L3:
                            nColor = MbeColors.PRINT_L3;
                            break;
                        case MbeLayer.LayerValue.SOL:
                            nColor = MbeColors.PRINT_SOL;
                            //reverse = true;
                            break;
                        case MbeLayer.LayerValue.DIM:
                            nColor = MbeColors.PRINT_DIM;
                            break;
                        default:
                            nColor = MbeColors.PRINT_DOC;
                            break;
                    }
                    col = Color.FromArgb(unchecked((int)nColor));
                    col = Color.FromArgb(255, col);
                } else {
                    col = Color.Black;
                }
			} else {
				uint nColor;
				switch (dp.layer) {
					case MbeLayer.LayerValue.PLC:
						nColor = MbeColors.PLC;
						break;
					case MbeLayer.LayerValue.PLS:
						nColor = MbeColors.PLS;
						//reverse = true;
						break;
					case MbeLayer.LayerValue.STC:
						nColor = MbeColors.STC;
						break;
					case MbeLayer.LayerValue.STS:
						nColor = MbeColors.STS;
						//reverse = true;
						break;
					case MbeLayer.LayerValue.CMP:
						nColor = MbeColors.CMP;
						break;
                    case MbeLayer.LayerValue.L2:
                        nColor = MbeColors.L2;
                        break;
                    case MbeLayer.LayerValue.L3:
                        nColor = MbeColors.L3;
                        break;
                    case MbeLayer.LayerValue.SOL:
						nColor = MbeColors.SOL;
						//reverse = true;
						break;
					case MbeLayer.LayerValue.DIM:
						nColor = MbeColors.DIM;
						break;
					default:
						nColor = MbeColors.DOC;
						break;
				}

				if (dp.mode == MbeDrawMode.Temp) {
					col = Color.FromArgb(255, MbeColors.HighLighten(nColor));
					//col = Color.FromArgb(MBE_OBJ_ALPHA, MbeColors.HighLighten(nColor));
				} else {
					col = Color.FromArgb(unchecked((int)nColor));
					col = Color.FromArgb(255, col);
					//col = Color.FromArgb(MBE_OBJ_ALPHA, col);
				}
			}

			bool reverse = false;
			switch (dp.layer) {
				case MbeLayer.LayerValue.PLS:
				case MbeLayer.LayerValue.STS:
				case MbeLayer.LayerValue.SOL:
					reverse = true;
					break;
				default:
					reverse = false;
					break;
			}


			if (dp.layer != MbeLayer.LayerValue.DOC) {
				GraphicsState gState = dp.g.Save();	//Wnۑ
				dp.g.TranslateTransform(pt0.X, pt0.Y);
				if (dir != 0) {
					dp.g.RotateTransform(-dir);
				}
				MbeView.boardFont.DrawString(dp.g, 0, 0, reverse, signame, h, w, col);
				dp.g.Restore(gState);					//WnA
			} else {
				if (h >= 2) {
					Font font = new Font(FontFamily.GenericSerif, h, GraphicsUnit.Pixel);
					Brush brush = new SolidBrush(col);
					StringFormat format = new StringFormat(StringFormatFlags.NoClip);
					format.Alignment = StringAlignment.Near;
					format.LineAlignment = StringAlignment.Far;

					GraphicsState gState = dp.g.Save();	//Wnۑ
					dp.g.TranslateTransform(pt0.X, pt0.Y);
					if (dir != 0) {
						dp.g.RotateTransform(-dir);
					}
					dp.g.DrawString(signame, font, brush, new PointF(0, 0), format);
					dp.g.Restore(gState);					//WnA

					format.Dispose();
					brush.Dispose();
					font.Dispose();
				}
			}
			

			if (drawSnapMark && dp.mode != MbeDrawMode.Print) {
				int marksize = h / 3;
				if (marksize > 20) marksize = 20;
				DrawSnapPointMark(dp.g, pt0, marksize, selectFlag[0]);
			}
		}

        public override MbeRect OccupationRect()
		{
			LinkedList<CamOutBaseData> camdataLList = new LinkedList<CamOutBaseData>();
			bool reverse;
			switch (layer) {
				case MbeLayer.LayerValue.PLS:
				case MbeLayer.LayerValue.STS:
				case MbeLayer.LayerValue.SOL:
					reverse = true;
					break;
				default:
					reverse = false;
					break;
			}
			MbeView.boardFont.GenerateCamDataString(camdataLList, 0, 0, reverse, signame, TextHeight, LineWidth);
			int l = System.Int32.MaxValue;
			int t = System.Int32.MinValue;
			int r = System.Int32.MinValue;
			int b = System.Int32.MaxValue;
			Point ptz = new Point(0, 0);
			Point ptOrigin = GetPos(0);
			foreach (CamOutBaseData camd in camdataLList) {
				if (dir != 0) {
					camd.RotateStep90(dir, ptz);
				}
				camd.Move(ptOrigin);
				if (camd.ctype == CamOutBaseData.CamType.VECTOR) {
					if (l > camd.pt0.X) l = camd.pt0.X;
					if (l > camd.pt1.X) l = camd.pt1.X;
					if (r < camd.pt0.X) r = camd.pt0.X;
					if (r < camd.pt1.X) r = camd.pt1.X;

					if (b > camd.pt0.Y) b = camd.pt0.Y;
					if (b > camd.pt1.Y) b = camd.pt1.Y;
					if (t < camd.pt0.Y) t = camd.pt0.Y;
					if (t < camd.pt1.Y) t = camd.pt1.Y;
				}
			}
			l -= LineWidth/2;
			t += LineWidth / 2;
			r += LineWidth / 2;
			b -= LineWidth / 2;
			MbeRect rc = new MbeRect(new Point(l, t), new Point(r, b));
			return rc;
		}

		/// <summary>
		/// |Ŝ߂̗֊sf[^𐶐B
		/// </summary>
		/// <param name="outlineList"></param>
		/// <param name="param"></param>
		/// <remarks>Ő֊sf[^͓ɏdȂĂĂǂ̂Ƃ
		/// }WɈ悲ƂɏƁA̗ʂ[łȂ傫Ȃ
		/// Ƃ肠͑Ŝ`ň͂ޗ֊s𐶐B
		/// </remarks>
		public override void GenerateOutlineData(LinkedList<MbeGapChkObjLine> outlineList, GenOutlineParam param)
		{
			if (layer != param.layer) return;

			MbeRect rc = OccupationRect();

			//LinkedList<CamOutBaseData> camdataLList = new LinkedList<CamOutBaseData>();

			//bool reverse;
			//switch (layer) {
			//    case MbeLayer.LayerValue.PLS:
			//    case MbeLayer.LayerValue.STS:
			//    case MbeLayer.LayerValue.SOL:
			//        reverse = true;
			//        break;
			//    default:
			//        reverse = false;
			//        break;
			//}
			//MbeView.boardFont.GenerateCamDataString(camdataLList, 0, 0, reverse, signame, TextHeight, LineWidth);
			//int l = System.Int32.MaxValue;
			//int t = System.Int32.MinValue;
			//int r = System.Int32.MinValue;
			//int b = System.Int32.MaxValue;
			//Point ptz = new Point(0, 0);
			//Point ptOrigin = GetPos(0);
			//foreach (CamOutBaseData camd in camdataLList) {
			//    if (dir != 0) {
			//        camd.RotateStep90(dir, ptz);
			//    }
			//    camd.Move(ptOrigin);
			//    if (camd.ctype == CamOutBaseData.CamType.VECTOR) {
			//        if (l > camd.pt0.X) l = camd.pt0.X;
			//        if (l > camd.pt1.X) l = camd.pt1.X;
			//        if (r < camd.pt0.X) r = camd.pt0.X;
			//        if (r < camd.pt1.X) r = camd.pt1.X;

			//        if (b > camd.pt0.Y) b = camd.pt0.Y;
			//        if (b > camd.pt1.Y) b = camd.pt1.Y;
			//        if (t < camd.pt0.Y) t = camd.pt0.Y;
			//        if (t < camd.pt1.Y) t = camd.pt1.Y;
			//    }
			//}
			int distance = param.traceWidth/ 2 + param.gap;

			int l = rc.L - distance;
			int t = rc.T + distance;
			int r = rc.R + distance;
			int b = rc.B - distance;
			Point[] pt = new Point[4];
			pt[0] = new Point(l, t);
			pt[1] = new Point(r, t);
			pt[2] = new Point(r, b);
			pt[3] = new Point(l, b);
			for (int j = 0; j < 4; j++) {
				int j2 = j + 1;
				if (j2 == 4) {
					j2 = 0;
				}
				if (!Util.LineIsOutsideLTRB(pt[j], pt[j2], param.rc)) {
					MbeGapChkObjLine objLine = new MbeGapChkObjLine();
					objLine.SetLineValue(pt[j], pt[j2], param.traceWidth);
					outlineList.AddLast(objLine);
				}
			}
		}

		/// <summary>
		/// CAMf[^̐ 
		/// </summary>
		/// <param name="camOut"></param>
		public override void GenerateCamData(CamOut camOut)
		{
			if (layer == MbeLayer.LayerValue.DOC) return;
			LinkedList<CamOutBaseData> camdataLList = new LinkedList<CamOutBaseData>();
			bool reverse;
			switch (layer) {
				case MbeLayer.LayerValue.PLS:
				case MbeLayer.LayerValue.STS:
				case MbeLayer.LayerValue.SOL:
					reverse = true;
					break;
				default:
					reverse = false;
					break;
			}
			MbeView.boardFont.GenerateCamDataString(camdataLList, 0, 0, reverse, signame, TextHeight, LineWidth);
			Point ptz= new Point(0, 0);
			Point pt = GetPos(0);
			foreach (CamOutBaseData camd in camdataLList) {
				if (dir!=0) {
					camd.RotateStep90(dir,ptz);
				}
				camd.Move(pt);
				camd.layer = layer;
				camOut.Add(camd);
			}
		}

		public override void GenerateGapChkData(LinkedList<MbeGapChkObj> chkObjList,int _netNum)
		//public override void GenerateGapChkData(MbeGapChk gapChk, int _netNum)
		{
			if (layer != MbeLayer.LayerValue.CMP &&
                layer != MbeLayer.LayerValue.L2 &&
                layer != MbeLayer.LayerValue.L3 &&
                layer != MbeLayer.LayerValue.SOL) {
				return;
			} else {
				bool reverse = (layer == MbeLayer.LayerValue.SOL);
				LinkedList<CamOutBaseData> camdataLList = new LinkedList<CamOutBaseData>();

				MbeView.boardFont.GenerateCamDataString(camdataLList, 0, 0, reverse, signame, TextHeight, LineWidth);
				Point ptz = new Point(0, 0);
				Point pt = GetPos(0);
				foreach (CamOutBaseData camd in camdataLList) {
					if (dir != 0) {
						camd.RotateStep90(dir, ptz);
					}
					camd.Move(pt);
					if (camd.pt0.Equals(camd.pt1)) {
						MbeGapChkObjPoint gapChkObj = new MbeGapChkObjPoint();
						gapChkObj.layer = layer;
						gapChkObj.netNum = _netNum;
						gapChkObj.mbeObj = this;
						gapChkObj.SetPointValue(camd.pt0, LineWidth);
						//gapChk.Add(gapChkObj);
						chkObjList.AddLast(gapChkObj);
					} else {
						MbeGapChkObjLine gapChkObj = new MbeGapChkObjLine();
						gapChkObj.layer = layer;
						gapChkObj.netNum = _netNum;
						gapChkObj.mbeObj = this;
						gapChkObj.SetLineValue(camd.pt0, camd.pt1, LineWidth);
						//gapChk.Add(gapChkObj);
						chkObjList.AddLast(gapChkObj);
					}
				}
			}
		}


 
		//protected string text;
		protected int lineWidth;
		protected int textHeight;
		//protected bool vertical;
		protected int dir;

	}
}
